#!/usr/bin/bash
echo "update logging configuration..."
sudo sh -c "echo '*.info;mail.none;authpriv.none;cron.none /dev/ttyS0' >> /etc/rsyslog.conf"
sudo systemctl restart rsyslog

echo logged in as $USER.
echo in directory $PWD


#echo "installing MariaDB..."
## sudo yum install mysql -y
#sudo dnf install mariadb-server -y
#sudo systemctl start mariadb
#sudo systemctl status mariadb
#sudo systemctl enable mariadb


echo "creating mysql_secure_installation.txt..."
touch mysql_secure_installation.txt
cat << `EOF` >> mysql_secure_installation.txt

n
Y
comsc
comsc
Y
Y
Y
Y
Y
`EOF`

echo "running mysql_secure_installation..."
sudo mysql_secure_installation < mysql_secure_installation.txt


sudo yum install git -y
# new 2025 - Git install messes up the ssh even if you do an update at the beginning we need to re install ssh after git.
sudo dnf update openssh-server openssh-client -y

echo "needs to be in root account"
cd root


echo "now needs to be in rocky user directory"
cd /home/rocky

cat << `EOF` >> matrix_keypair.key
-----BEGIN OPENSSH PRIVATE KEY-----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=
-----END OPENSSH PRIVATE KEY-----
`EOF`

sudo chmod 400 matrix_keypair.key
sudo ssh-agent bash -c 'ssh-add matrix_keypair.key'
cd ~/
sudo touch .ssh/known-hosts
#touch .ssh/known_hosts
sudo ssh-keyscan git.cardiff.ac.uk >> .ssh/known_hosts
sudo chmod 644 .ssh/known_hosts
cd /home/rocky
echo "Cloning Git Repo..."
sudo ssh-agent bash -c 'ssh-add matrix_keypair.key; git clone git@git.cardiff.ac.uk:c24020257/sports-league-application.git'
echo "Entering Git Repo directory..."
cd sports-league-application

echo "installing MariaDB..."
# sudo yum install mysql -y
sudo dnf install mariadb-server -y
sudo systemctl start mariadb
sudo systemctl status mariadb
sudo systemctl enable mariadb

mysql -uroot -pcomsc < src/main/resources/sports.sql


sudo yum install java-17-openjdk -y

sudo yum install wget -y
wget https://services.gradle.org/distributions/gradle-7.6-bin.zip

sudo yum install unzip -y
sudo mkdir /opt/gradle
sudo unzip -d /opt/gradle gradle-7.6-bin.zip
export PATH=$PATH:/opt/gradle/gradle-7.6/bin

gradle build
gradle bootrun