package uk.ac.cf.spring.demo.sports.Userdetail;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.ResponseEntity;

import java.util.List;

@RequestMapping("/detail")
@RestController()
public class UserDetailController {
    @Autowired
    private UserService userService;

    // 使用 @Autowired 进行依赖注入（构造函数注入）
    @Autowired
    public UserDetailController(UserService userService) {
        this.userService = userService;
    }

    // 获取所有用户列表
    @GetMapping("/users")
    public List<userdetails> getAllUsers() {
        List<userdetails>users=userService.getAllUsers();
        return users;
    }

    // 通过用户 ID 获取用户详情
    @GetMapping("/{id}")
    public userdetails getUserById(@PathVariable Long id) {
        return userService.getUserById(id);
    }

    // 添加用户
    @PostMapping
    public void addUser(@RequestBody userdetails user) {
        userService.addUser(user);
    }

    // 更新用户信息
    @PutMapping("/{id}")
    public void updateUser(@PathVariable Long id, @RequestBody userdetails user) {
        userService.updateUser(user);
    }

    // 删除用户
    @DeleteMapping("/{id}")
    public void deleteUser(@PathVariable Long id) {
        userService.deleteUser(id);
    }
}