package uk.ac.cf.spring.demo.sports.images;
import java.io.IOException;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

@RestController
@RequestMapping("/api/images")
public class ImageController {
    private final ImageService imageService;

    @Autowired
    public ImageController(ImageService imageService) {
        this.imageService = imageService;
    }

    @GetMapping
    public List<Image> getImages() {
        List<Image> images = imageService.getAllImages();
        System.out.println("Returned JSON data: " + images);
        return imageService.getAllImages();
    }

    @PostMapping
    public ResponseEntity<Void> uploadImage(@RequestParam("image") MultipartFile file) {
        try {
            imageService.saveImage(file);
            List<Image> images = imageService.getAllImages();
            System.out.println("Returned JSON data: " + images);
            return ResponseEntity.ok().build();
        } catch (IOException e) {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).build();
        }
    }
}

