package uk.ac.cf.spring.demo.sports.match;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
//inject
@Service
public class MatchServiceListImpl implements MatchService{
    //inject repository
    @Autowired
    private MatchRepository matchRepository;
    public MatchServiceListImpl(MatchRepository aMatchRepository) {
        this.matchRepository = aMatchRepository;
    }
    @Override
    public List<MatchItem> getMatchItems() {
        return matchRepository.getMatchItems();
    }

    @Override
    public MatchItem getMatchItemById(Long id) {
        return matchRepository.getMatchItemById(id);
    }

    @Override
    public List<MatchItem> getMatchItemBySport(String sport) {
        return matchRepository.getMatchItemBySport(sport);
    }
    //    add
    @Override
    public void addMatchItem(MatchItem matchItem) {
        matchRepository.addMatchItem(matchItem);
    }
    // update
    @Override
    public void updateMatchItem(MatchItem matchItem) {
        if (matchItem.getId() == null || matchItem.getId() <= 0) {
            throw new IllegalArgumentException("Invalid Match Item ID");
        }
        MatchItem existingItem = matchRepository.getMatchItemById(matchItem.getId());
        if (existingItem != null) {
            matchRepository.updateMatchItem(matchItem);
        } else {
            throw new IllegalArgumentException("Match item not found");
        }

    }
    // delete
    @Override
    public void deleteMatchItem(Long id) {
            matchRepository.deleteMatchItem(id);
    }
}
