//package uk.ac.cf.spring.demo.user.controller;
//
//import org.junit.After;
//import org.junit.Before;
//import org.junit.BeforeClass;
//import org.junit.Test;
//import org.junit.jupiter.api.AfterEach;
//import org.junit.jupiter.api.BeforeAll;
//import org.junit.jupiter.api.BeforeEach;
//import org.junit.jupiter.api.TestInstance;
//import org.junit.jupiter.api.extension.ExtendWith;
//import org.junit.runner.RunWith;
//import org.openqa.selenium.By;
//import org.openqa.selenium.WebDriver;
//import org.openqa.selenium.WebElement;
//import org.openqa.selenium.firefox.FirefoxDriver;
//import org.openqa.selenium.firefox.FirefoxOptions;
//import org.openqa.selenium.support.ui.ExpectedConditions;
//import org.openqa.selenium.support.ui.WebDriverWait;
//import org.springframework.beans.factory.annotation.Value;
//import org.springframework.boot.test.context.SpringBootTest;
//import org.springframework.test.context.junit.jupiter.SpringExtension;
//import org.springframework.test.context.junit4.SpringRunner;
//import io.github.bonigarcia.wdm.WebDriverManager;
//
//import java.io.File;
//import java.time.Duration;
//
////import static org.junit.Assert.assertTrue;
//import static org.junit.jupiter.api.Assertions.assertTrue;
//import static org.assertj.core.api.Assertions.assertThat;
//
//
////@RunWith(SpringRunner.class)
//@ExtendWith(SpringExtension.class)
//@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
////@TestInstance(TestInstance.Lifecycle.PER_CLASS)
//public class DriverPageTests {
//
//    @Value("${local.server.port}")
//    private int port;
//
//    private WebDriver webDriver;
//    private WebDriverWait wait;
//
//
//    @BeforeAll
//    public static void setupClass() {
//        WebDriverManager.firefoxdriver().setup();
//    }
//
//    @BeforeEach
//    public void setupTest() {
//        // Get the current working directory
//        String currentDir = System.getProperty("user.dir");
//
//        // Set the path to the local geckodriver executable
//        System.setProperty("webdriver.gecko.driver", currentDir + File.separator + "geckodriver.exe");
//        FirefoxOptions options = new FirefoxOptions();
//        options.addArguments("--headless");
//        webDriver = new FirefoxDriver(options);
//        wait = new WebDriverWait(webDriver, Duration.ofSeconds(10));
//    }
//
//    @AfterEach
//    public void teardown() {
//        if (webDriver != null) {
//            webDriver.quit();
//        }
//    }
//
//    @Test
//    public void testUserManagementPage() {
//        // Test fetching and displaying users
//        webDriver.get("http://localhost:" + port + "/html/backGroundUser.html");
//        assertTrue(webDriver.findElement(By.cssSelector("#userTable")).isDisplayed());
//
//        // Test adding a new user
//        webDriver.findElement(By.id("username")).sendKeys("shy");
//        webDriver.findElement(By.id("email")).sendKeys("shy@creditsafe.com");
//        webDriver.findElement(By.id("password")).sendKeys("$2a$16$R0aSGzbklUhpRfIMhocewephgUDMFOffLb7faSwwHusqHh81G026i");
//        webDriver.findElement(By.id("role")).sendKeys("USER");
//        webDriver.findElement(By.xpath("//button[text()='Add User']")).click();
//        assertTrue(webDriver.findElement(By.cssSelector("#userTable")).getText().contains("shy"));
//
//        // Test editing a user
//        webDriver.findElement(By.xpath("//tr[td[text()='shy']]//button[text()='Edit']")).click();
//        webDriver.findElement(By.id("email")).clear();
//        webDriver.findElement(By.id("email")).sendKeys("upu@creditsafe.com");
//        webDriver.findElement(By.xpath("//button[text()='Update User']")).click();
//        assertTrue(webDriver.findElement(By.cssSelector("#userTable")).getText().contains("upu@creditsafe.com"));
//
//        // Test deleting a user
//        webDriver.findElement(By.xpath("//tr[td[text()='shy']]//button[text()='Delete']")).click();
//        assertThat(webDriver.findElement(By.cssSelector("#userTable")).getText()).doesNotContain("shy");
//    }
//}